<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'withdraw';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);
$smarty->assign('submenu', 'point');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 会员模块
include_once (ROOT_PATH . 'include/user.class.php');
$dou_user = new DouUser();

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center('withdraw', 'admin'));

/**
 * +----------------------------------------------------------
 * 提现列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['withdraw']);
 
    // 初始化
    $page_url = 'withdraw.php';
 
    // 用户名
    $username = $check->is_username($_REQUEST['username']) ? $_REQUEST['username'] : '';
    if ($username) {
        $user_id = $dou->search_user_id($username);
        $where = " AND user_id = '$user_id'";
        $page_url = $page_url . "&username=$username";
    }

    // 筛选.类型
    $withdraw_sn = $check->is_number($_REQUEST['withdraw_sn']) ? $_REQUEST['withdraw_sn'] : '';
    if ($withdraw_sn) {
        $where = $where . " AND withdraw_sn LIKE '%$withdraw_sn%'";
        $page_url = $page_url . "&withdraw_sn=$withdraw_sn";
    }
 
    // 筛选.时间
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    if ($time_start) {
        $where = $where . " AND add_time > '" . strtotime($time_start) . "'";
        $page_url = $page_url . "&time_start=$time_start";
    }
    if ($time_end) {
        $where = $where . " AND add_time < '" . strtotime($time_end) . "'";
        $page_url = $page_url . "&time_end=$time_end";
    }
 
    // 格式化
    $where = $_SESSION['where'] = $dou->where($where);
    $page_url = $dou->param($page_url);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('user_withdraw') . $where . " ORDER BY id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, $page_url);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $withdraw_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "withdraw_sn" => $row['withdraw_sn'],
                "money" => $row['money'],
                "card_number" => $row['card_number'],
                "card_bank" => $row['card_bank'],
                "card_name" => $row['card_name'],
                "handle_record" => $row['handle_record'],
                "handle_time" => $row['handle_time'] ? date("Y-m-d H:i", $row['handle_time']) : '-',
                "status" => $dou->data_lang_format('withdraw_status_', $row['status']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 赋值给模板
    $smarty->assign('req', $_REQUEST);
    $smarty->assign('withdraw_list', $withdraw_list);
    $smarty->assign('page', $page);
    
    $smarty->display('withdraw.htm');
} 

/**
 * +----------------------------------------------------------
 * 提现编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'view') {
    $smarty->assign('ur_here', $_LANG['withdraw']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['withdraw_list'],
            'href' => 'withdraw.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    // 格式化服务单信息
    $withdraw = $dou->get_row('user_withdraw', '*', "id = '$id'");
    $withdraw['money_format'] = $withdraw['money'] > 0 ? $dou->price_format($withdraw['money']) : '无退款';
    $withdraw['is_handle'] = $withdraw['status'] ? true : false; // 是否可以操作提现
    $withdraw['status'] = $dou->data_lang_format('withdraw_status_', $withdraw['status']);
    $withdraw['add_time'] = date("Y-m-d H:i:s", $withdraw['add_time']);
    $withdraw['user'] = $dou->get_row('user', 'user_id, user_sn, email', "user_id = '$withdraw[user_id]'");
    $withdraw['user']['money'] = $dou_user->money($withdraw['user_id']); // 获取当前账号余额
 
    // 强制解锁
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('withdraw', $withdraw);
    $smarty->assign('unlock', $unlock);
    
    $smarty->display('withdraw.htm');
}

/**
 * +----------------------------------------------------------
 * 提现处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'handle') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
 
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    // 提现信息
    $withdraw = $dou->get_row('user_withdraw', '*', "id = '$id'");
    if ($withdraw['status'] == 1 && !$unlock) // 强制解锁状态可以重复修改提现信息
        $dou->dou_msg('不能操作该提现单');
    
    // 格式化数据
    $handle_time = time();
 
    // 变更提现状态
    $dou->query("UPDATE " . $dou->table('user_withdraw') . " SET handle_record = '$_POST[handle_record]', handle_time = '$handle_time', `status` = '1' WHERE id = '$id'");
    
    $dou->dou_header('withdraw.php?rec=view&id=' . $id);
}

/**
 * +----------------------------------------------------------
 * 解锁提现账户
 * +----------------------------------------------------------
 */
elseif ($rec == 'card_unlock') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
 
    // 提现信息
    $withdraw = $dou->get_row('user_withdraw', '*', "id = '$id'");
    if ($withdraw['card_status'] == 0) // 不是锁定状态就无需操作解锁
        $dou->dou_msg('不能操作该提现单');
 
    // 变更提现状态
    $dou->query("UPDATE " . $dou->table('user_withdraw') . " SET card_status = '0' WHERE id = '$id'");
    
    $dou->dou_header('withdraw.php?rec=view&id=' . $id);
}

?>