// pages/withdraw/apply.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
  },
 
  onShow: function () {
    var that = this;
    
    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
    
    that.setData({
      title: app.title.withdraw_apply
    })
    
    // 显示转发按钮
    dou.showShareMenu()
   
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    wx.request({
      url: app.mp_url + 'withdraw.php?rec=apply',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell')
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong, '/pages/withdraw/user')
        }
        
        that.setData({
          withdraw: res.data.withdraw,
          money_total: res.data.money_total
        })
      },
    })
  },
 
  withdrawApply: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.request({
      url: app.mp_url + 'withdraw.php?rec=apply_post',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        post: JSON.stringify(e.detail.value)
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function (res) {
        if (res.data.wrong) {
          that.setData({
            wrong: res.data.wrong
          });
        } else {
          dou.douMsg(that.data.lang.withdraw_apply_success, '/pages/withdraw/user')
        }
      }
    })
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }

})