<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'user|apply';
$subbox = array(
        "module" => 'withdraw',
        "sub" => $sub
);

$_CUR = 'withdraw';
require (dirname(__FILE__) . '/include/init.php');

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/money.class.php');
$dou_money = new Money();

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'user';

// 权限验证
$callback = $dou_user->check_login_state(); // 登录验证
if ($callback['msg'] == 'ok') {
    $user_id = $callback['user_id'];
} else {
    $data['wrong'] = $_LANG['login_timeout'];
    die(json_encode($data));
}

// 错误提示初始
$data['wrong'] = '';

/**
 * +----------------------------------------------------------
 * 提现.会员中心
 * +----------------------------------------------------------
 */
if ($rec == 'user') {
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('user_withdraw') . " WHERE user_id = '$user_id' ORDER BY id DESC";
    
    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, 10, $page);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $withdraw_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "withdraw_sn" => $row['withdraw_sn'],
                "money" => $row['money'],
                "card_number" => $row['card_number'],
                "card_bank" => $row['card_bank'],
                "card_name" => $row['card_name'],
                "handle_record" => $row['handle_record'],
                "handle_time" => $row['handle_time'] ? date("Y-m-d H:i", $row['handle_time']) : '',
                "status" => $dou->data_lang_format('withdraw_status_', $row['status']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
 
    // 验证是否重复申请
    $old_withdraw = $dou->get_one("SELECT COUNT(*) FROM " . $dou->table('user_withdraw') . " WHERE user_id = '$user_id' AND status = 0");
    
    if ($old_withdraw) {
        $data['apply_exist'] = true;
    }
 
    // 数据封装
    $data['title'] = $_LANG['withdraw_list'];
    $data['withdraw_list'] = $withdraw_list;
    $data['money_total'] = $dou_user->money($user_id);
}

/**
 * +----------------------------------------------------------
 * 提现.申请
 * +----------------------------------------------------------
 */
elseif ($rec == 'apply') {
    // 验证是否重复申请
    $old_withdraw = $dou->get_one("SELECT COUNT(*) FROM " . $dou->table('user_withdraw') . " WHERE user_id = '$user_id' AND status = 0");
    
    if ($old_withdraw) {
        // 错误提示
        $data['wrong'] = $_LANG['withdraw_apply_exist'];
        die(json_encode($data));
    }
    
    // 获取最近一次的收款账号信息
    $withdraw = $dou->get_row('user_withdraw', '*', "user_id = '$user_id' ORDER BY id DESC"); // 获取最近一条提现记录
 
    // 数据封装
    $data['title'] = $_LANG['withdraw_apply'];
    $data['withdraw'] = $withdraw;
    $data['money_total'] = $dou_user->money($user_id);
}

/**
 * +----------------------------------------------------------
 * 提现.提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'apply_post') {
    // 合并数组
    $_POST = array_merge($_POST, get_object_vars(json_decode(str_replace("\\", "", $_REQUEST['post']))));
   
    $withdraw = $dou->get_row('user_withdraw', '*', "user_id = '$user_id' ORDER BY id DESC"); // 获取最近一条提现记录
    $money = $dou_user->money($user_id); // 获取当前账号余额
   
    // 判断是否为空
    $wrong = $check->fn_empty('withdraw', 'money');
    if ($withdraw['card_status'] != 1) {
        $wrong = $check->fn_empty('withdraw', 'card_number, card_bank, card_name');
        $wrong = $check->fn_illegal_char('withdraw', 'card_number, card_bank, card_name');
    }
 
    // 验证提现金额
    if (!$check->is_price($_POST['money']) && $_POST['money'] > 0)
        $wrong['money'] = $_LANG['withdraw_money_cue'];

    // 验证最大可提现金额
    if ($_POST['money'] > $money)
        $wrong['money'] = $_LANG['withdraw_money_out'];

    // 错误提示
    $data['wrong'] = $wrong;
    if ($data['wrong']) {
        die(json_encode($data));
    }
 
    // 验证是否重复申请
    $old_withdraw = $dou->get_one("SELECT COUNT(*) FROM " . $dou->table('user_withdraw') . " WHERE user_id = '$user_id' AND status = 0");
    if ($old_withdraw) {
        // 错误提示
        $data['wrong'] = $_LANG['withdraw_apply_exist'];
        die(json_encode($data));
    }

    // 获取和格式化数据
    $withdraw_sn = create_withdraw_sn();
    $card_number = $withdraw['card_number'] ? $withdraw['card_number'] : $_POST['card_number'];
    $card_bank = $withdraw['card_bank'] ? $withdraw['card_bank'] : $_POST['card_bank'];
    $card_name = $withdraw['card_name'] ? $withdraw['card_name'] : $_POST['card_name'];
    $add_time = time();

    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);

    // 提现信息插入
    $sql = "INSERT INTO " . $dou->table('user_withdraw') . " (id, withdraw_sn, user_id, money, card_number, card_bank, card_name, card_status, add_time)" . " VALUES (NULL, '$withdraw_sn', '$user_id', '$_POST[money]', '$card_number', '$card_bank', '$card_name', '1', '$add_time')";
    if ($dou->query($sql))
        $dou_user->create_money($user_id, 'user_withdraw', $_POST['money']*(-1), $withdraw_sn); // 写入财务记录
}

echo json_encode($data);

/**
 * +----------------------------------------------------------
 * 生成唯一的退换货编号
 * +----------------------------------------------------------
 */
function create_withdraw_sn() {
    // 随机生成订单号
    $withdraw_sn = str_pad(mt_rand(1, 99999), 6, '0', STR_PAD_LEFT);

    if ($GLOBALS['dou']->value_exist('user_withdraw', 'withdraw_sn', $withdraw_sn)) {
        create_withdraw_sn();
    }

    return $withdraw_sn;
}

?>